"
    __________________________________________________
    @Alejandro F. Reimondo 18/feb/99
    This proyect sources are property of : Alejandro F. Reimondo
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-11-4703-5586.
    __________________________________________________
"

Application create: #WizLibraryApp with:
    (#( AbtViewApplication)
        collect: [:each | Smalltalk at: each ifAbsent: [
            Application errorPrerequisite: #WizLibraryApp missing: each]])!


WizLibraryApp becomeDefault!
System image globalNamespace
  poolDictionaryAt: #WizPlatformFunctions
  ifAbsent: [
     System image globalNamespace
        declarePoolDictionary: #WizPlatformFunctions
	].!

WizLibraryApp becomeDefault!
| functions |
functions := (System image globalNamespace poolDictionaryAt: #WizPlatformFunctions ifAbsent: [Dictionary new]).
#('ZpArchive' 'ZpArchivePtr' 'ZpGetOptionsPtr' 'ZpInit' 'ZpSetOptions' 'ZpVersion')
do: [:key| functions at: key put: #undefined ].!

WizLibraryApp becomeDefault!
OSStructure subclass: #WizStructure
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: 'WizPlatformFunctions '!

WizLibraryApp becomeDefault!
WizStructure subclass: #ZCL
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

WizLibraryApp becomeDefault!
WizStructure subclass: #ZipUserFunctions
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

WizLibraryApp becomeDefault!
WizStructure subclass: #ZipVersionType
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

WizLibraryApp becomeDefault!
WizStructure subclass: #ZpOptions
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

WizLibraryApp becomeDefault!
WizStructure subclass: #ZpVer
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

WizLibraryApp becomeDefault!
Application subclass: #WizLibraryApp
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

WizLibraryApp becomeDefault!
Object subclass: #WizObject
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

WizLibraryApp becomeDefault!
WizObject subclass: #WizArchiver
    classInstanceVariableNames: 'current '
    instanceVariableNames: 'options password '
    classVariableNames: ''
    poolDictionaries: ''!

WizLibraryApp becomeDefault!
WizObject variableByteSubclass: #WizDLL
    classInstanceVariableNames: 'current '
    classVariableNames: ''
    poolDictionaries: 'WizPlatformFunctions '!


WizLibraryApp becomeDefault!

!WizArchiver class publicMethods !

current
	"Returns the current library in use."

	current isNil ifTrue: [ self initializeCurrent ].
	^current! !

!WizArchiver class privateMethods !

current: aCurrent
	" Private - Sets the current library in use."

	current := aCurrent!

initializeCurrent
	" Private - Returns the current library in use."

	current := self new.! !

!WizArchiver publicMethods !

comment
	"Put comment in zip file"

	^self options comment!

comment: aBoolean
	"Put comment in zip file"

	^self options comment: aBoolean asParameter!

crlfLf
	"Translate CR/LF to LF"

	^self options crlfLf!

crlfLf: aBoolean
	"Translate CR/LF to LF"

	^self options crlfLf: aBoolean asParameter!

date
	"Date to include after"

	| bytes string |
	bytes := self options date.
	bytes detect: [:byte| byte ~= 0 ] ifNone: [ ^nil ].
	string := String new: bytes size.
	1 to: string size do: [:i| string at: i put: (bytes at: i) asCharacter ].
	^"Date fromString:" string!

date: aDate
	"Date to include after"

	^self options date: aDate formPrint asParameter!

deleteEntries
	"Delete files from zip file"

	^self options deleteEntries!

deleteEntries: aBoolean
	"Delete files from zip file"

	^self options deleteEntries: aBoolean asParameter!

dll
	"Returns the receiver's current DLL support."

	^WizDLL current!

doUpdate
	"Update zip file--overwrite only if newer"

	^self options update!

doUpdate: aBoolean
	"Update zip file--overwrite only if newer"

	^self options update: aBoolean asParameter!

encrypt
	"encrypt files"

	^self options encrypt!

encrypt: aBoolean
	"encrypt files"

	^self options encrypt: aBoolean asParameter!

encryption
	"TRUE if encryption supported, else FALSE. This is a read only flag"

	^self options encryption!

encryption: aBoolean
	"TRUE if encryption supported, else FALSE. This is a read only flag"

	^self options encryption: aBoolean asParameter!

excludeDate
	"Exclude files earlier than specified date"

	^self options excludeDate!

excludeDate: aBoolean
	"Exclude files earlier than specified date"

	^self options excludeDate: aBoolean asParameter!

extra
	"Include extra attributes"

	^self options extra!

extra: aBoolean
	"Include extra attributes"

	^self options extra: aBoolean asParameter!

force
	"Make entries using DOS names (k for Katz)"

	^self options force!

force: aBoolean
	"Make entries using DOS names (k for Katz)"

	^self options force: aBoolean asParameter!

freshen
	"Freshen zip file--overwrite only"

	^self options freshen!

freshen: aBoolean
	"Freshen zip file--overwrite only"

	^self options freshen: aBoolean asParameter!

getPassword: title into: container
	"Get the password into the buffer."

	| psw |	
	psw := self getPassword: title.
	psw isNil ifTrue: [ ^-1 ].
	psw := psw asString ,(String with: 0 asCharacter).
	container
		replaceFrom: 1 to: psw size
		with: psw	startingAt: 1.

	"Return code of password fetches (negative: user abort; positive: error)
	0		got some PWD string, use/try it
	-1		no password available (for this entry)
	-2		no password, skip any further PWD request
	5		failure (no mem, no tty, ...)
	"
	^0!

grow
	"Allow appending to a zip file"

	^self options grow!

grow: aBoolean
	"Allow appending to a zip file"

	^self options grow: aBoolean asParameter!

includeDate
	"Include only files earlier than specified date"

	^self options includeDate!

includeDate: aBoolean
	"Include only files earlier than specified date"

	^self options includeDate: aBoolean asParameter!

junkDir
	"Junk directory names"

	^self options junkDir!

junkDir: aBoolean
	"Junk directory names"

	^self options junkDir: aBoolean asParameter!

junkSFX
	"Junk SFX prefix"

	^self options junkSFX!

junkSFX: aBoolean
	"Junk SFX prefix"

	^self options junkSFX: aBoolean asParameter!

latestTime
	"Set zip file time to time of latest file in it"

	^self options latestTime!

latestTime: aBoolean
	"Set zip file time to time of latest file in it"

	^self options latestTime: aBoolean asParameter!

level
	"Compression level (0 - 9)"

	^self options level!

level: anInteger
	"Compression level (0 - 9)"

	^self options level: anInteger asParameter!

lfCrlf
	"Translate LF to CR/LF"

	^self options lfCrlf!

lfCrlf: aBoolean
	"Translate LF to CR/LF"

	^self options lfCrlf: aBoolean asParameter!

move
	"Delete files added or updated in zip file"

	^self options move!

move: aBoolean
	"Delete files added or updated in zip file"

	^self options move: aBoolean asParameter!

noDirEntries
	"Do not add directory entries"

	^self options noDirEntries!

noDirEntries: aBoolean
	"Do not add directory entries"

	^self options noDirEntries: aBoolean asParameter!

offsets
	"Update archive offsets for SFX files"

	^self options offsets!

offsets: aBoolean
	"Update archive offsets for SFX files"

	^self options offsets: aBoolean asParameter!

options
	"Returns the instance var of the receiver
	 for external manipulation"

	options isNil ifTrue: [ self initializeOptions ].
	^options!

password
	"Returns the instance var of the receiver
	 for external manipulation"

	password isNil ifTrue: [ self initializePassword ].
	^password!

password: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	password := anObject!

print: buffer count: size
	"Dummy print method that simply outputs what is sent from the dll."

	| string |
	string := (OSPointer fromInteger: buffer)
		copyStringFrom: 1 to: size.
	Transcript cr;show: 'zip print: ',string printString.
	^size!

privilege
	"Use privileges (WIN32 only)"

	^self options privilege!

privilege: aBoolean
	"Use privileges (WIN32 only)"

	^self options privilege: aBoolean asParameter!

process: zipFileName with: fileNames
	"Perform archive action on files named fileNames changing zip file named zipFileName."

	| zpZCL addresses lpZipFileName structArray |
	zpZCL := self dll structureNamed: 'ZCL'.
	lpZipFileName := zipFileName asPointer.

	addresses := fileNames collect: [:each| each asPSZ copyToOSMemory"asPointer" ].
	structArray := ByteArray new: fileNames size * 4.
	1 to: addresses size do: [:i|
		structArray uint32At: i - 1 * 4 put: (addresses at: i)
	].

	zpZCL
		argc: fileNames size;
		lpszZipFN: lpZipFileName asParameter;
		fnv: structArray copyToOSMemory asParameter;
		yourself.

	self dll zpArchivePtr: zpZCL asParameter.

	addresses do: [:each| each free ].
	lpZipFileName free.!

quiet
	"Quiet operation"

	^self options quiet!

quiet: aBoolean
	"Quiet operation"

	^self options quiet: aBoolean asParameter!

recurse
	"Recurse into subdirectories"

	^self options recurse!

recurse: aBoolean
	"Recurse into subdirectories"

	^self options recurse: aBoolean asParameter!

repair
	"Repair archive. 1 => -F, 2 => -FF"

	^self options repair!

repair: anInteger
	"Repair archive. 1 => -F, 2 => -FF"

	^self options repair: anInteger asParameter!

rootDir
	"Directory to use as base for zipping"

	^self options rootDir!

rootDir: pathName
	"Directory to use as base for zipping"

	^self options rootDir: pathName asParameter!

suffix
	"Include suffixes (not implemented)"

	^self options suffix!

suffix: aBoolean
	"Include suffixes (not implemented)"

	^self options suffix: aBoolean asParameter!

system
	"include system and hidden files"

	^self options system!

system: aBoolean
	"include system and hidden files"

	^self options system: aBoolean asParameter!

verbose
	"Mention oddities in zip file structure"

	^self options verbose!

verbose: aBoolean
	"Mention oddities in zip file structure"

	^self options verbose: aBoolean asParameter!

volume
	"Include volume label"

	^self options volume!

volume: aBoolean
	"Include volume label"

	^self options volume: aBoolean asParameter! !

!WizArchiver privateMethods !

getPassword: title
	" Private - Returns the password."

	Transcript cr;show:'--->',title.
	^self password!

initializeOptions
	" Private - Initializes the receiver's options"

	options := self dll options.!

initializePassword
	" Private - Initializes the receiver's password"

"	self triggerEvent: #needPassword.		"! !

!WizDLL class publicMethods !

current
	"Returns the current library in use."

	current isNil ifTrue: [ self initializeCurrent ].
	^current!

fileName
		"Answer the receiver's file name."

	^'Wiz.dll'!

library
	"Returns the current library in use."

	^self current! !

!WizDLL class privateMethods !

callbackFor: action on: aReceiver
	" Private - Construct a proper callback object to send a message informing aReceiver for an action. "

	| tuple specification |
	tuple := #(
		"(action (selector (argumentsType) returnType))"
		(printing (print:count: (#uint32 #int32) #int32))
		(commenting (comment: (#uint32) #uint32))
		(encripting (password:n:m:name: (#uint32 #int32 #uint32 #uint32) #int32))
		)
		detect: [:one| one first = action ]
		ifNone: [ self error: 'Invalid action.' ].

	specification := tuple last.
	^EsEntryPoint
		receiver: aReceiver
		selector: specification first
		callingConvention: 'c'
		arrayBased: false
		parameterTypes: (specification at: 2)
		returnType: specification last
!

classForStructureNamed: aName
	" Private - Returns the platform structure class supporting structure named aName. "

	aName = 'ZPOPT' ifTrue: [ ^ZpOptions ].
	aName = 'ZCL' ifTrue: [ ^ZCL ].
	aName = 'ZIPUSERFUNCTIONS' ifTrue: [ ^ZipUserFunctions ].
	aName = '_zip_version_type' ifTrue: [ ^ZipVersionType ].
	aName = 'ZpVer' ifTrue: [ ^ZpVer ].

	^self error: 'Invalid structure name.'!

current: aCurrent
	" Private - Sets the current library in use."

	current := aCurrent!

initializeCurrent
	" Private - Returns the current library in use."

	current := self new.
	current initialize.!

initializeAfterLoad
	" Private - The receiver has just been loaded, initialize class variables.
	WizDLL initializeOnLoad.
	"

	^self initializePlatformFunctions!

initializeOnLoad
	" Private - The receiver has just been loaded, initialize class variables.
	WizDLL initializeOnLoad.
	"

	^self initializePlatformFunctions!

initializePlatformFunctions
	" Private - Initialize platform functions held by the receiver."

	| poolDictionary parameters poolName |
	poolDictionary := self platformFunctions.
	self platformFunctionSpecifications do: [:spec|
		poolName := spec first copy.
		poolName at: 1 put: poolName first asUppercase.
		parameters := OrderedCollection new.
		parameters
			add: 'C';
			add: spec first; "entryPointName"
			add: nil;
			add: self fileName;
			add: (spec at: 2); "parameterTypes"
			add: (spec at: 3); "returnType"
			yourself.
		poolDictionary
			at: poolName
			put: (PlatformFunction fromArray: parameters asArray)
	].

" To clear platform functions evaluate:
	WizDLL platformFunctions keys do: [:key| WizDLL platformFunctions removeKey: key ].
  ... and recompile all the class
"!

initializeStructures
	"Private - Initializes the structures for the interfase.
	WizDLL initializeStructures
	"

	super initializeStructures.
	self
		registerType: '_zip_version_type'
		as:#(
			(major byte)
			(minor byte)
			(patchlevel byte)
			(notUsed byte)
		);
		registerType: 'ZpVer'
		as:#(
			(structlen ulong) "length of the struct being passed"
			(flag ulong) "bit 0: is_beta   bit 1: uses_zlib"
			(betalevel (10 byte)) " 'g BETA' or empty"
			(date (20 byte))
			(zlibVersion (10 byte))
			(zip '_zip_version_type')
			(os2dll '_zip_version_type')
			(windll '_zip_version_type')
		);
		registerType: 'ZPOPT'			"zip options"
		as:#(
			(suffix boolean)	"include suffixes (not implemented)"
			(encrypt boolean)	"encrypt files"
			(system boolean)	"include system and hidden files"
			(volume boolean)	"Include volume label"
			(extra boolean)	"Include extra attributes"
			(noDirEntries boolean)	"Do not add directory entries"
			(excludeDate boolean)	"Exclude files earlier than specified date"
			(includeDate boolean)	"Include only files earlier than specified date"
			(verbose boolean)	"Mention oddities in zip file structure"
			(quiet boolean)	"Quiet operation"
			(crlfLf boolean)	"Translate CR/LF to LF"
			(lfCrlf boolean)	"Translate LF to CR/LF"
			(junkDir boolean)	"Junk directory names"
			(recurse boolean)	"Recurse into subdirectories"
			(grow boolean)	"Allow appending to a zip file"
			(force boolean)	"Make entries using DOS names (k for Katz)"
			(move boolean)	"Delete files added or updated in zip file"
			(deleteEntries boolean) "Delete files from zip file"
			(update boolean)	"Update zip file--overwrite only if newer"
			(freshen boolean)	"Freshen zip file--overwrite only"
			(junkSFX boolean)	"Junk SFX prefix"
			(latestTime boolean)	"Set zip file time to time of latest file in it"
			(comment boolean)	"Put comment in zip file"
			(offsets boolean)	"Update archive offsets for SFX files"
			(privilege boolean) "Use privileges (WIN32 only)"
			(encryption boolean)	"TRUE if encryption supported, else FALSE. This is a read only flag"
			(repair long)	"Repair archive. 1 => -F, 2 => -FF"
			(level byte)	"Compression level (0 - 9)"
			(date (9 byte))	"Date to include after"
			(rootDir 128 asCstring) "Directory to use as base for zipping"
		);
		registerType: 'ZCL'
		as:#(
			(argc long) "Count of files to zip"
			(lpszZipFN ulong) "name of archive to create/update"
			(fnv ulong) "array of file names to zip up"
		);
		registerType: 'ZIPUSERFUNCTIONS'
		as:#(
			(print ulong)
			(comment ulong)
			(password ulong)
		);
		yourself.
!

platformFunctions
	" Private - Returns the platformFunctions pool dictionary.
	WizDLL initializePlatformFunctions.
	"

	^System image globalNamespace
		poolDictionaryAt: #WizPlatformFunctions
		ifAbsent: [ self error: 'WizPlatformFunctions missing.' ]!

platformFunctionSpecifications
	" Private - Returns the specification array for platform functions. "

	^#(
	"(entryPointName #(parameterTypes) #returnType)"
	( 'ZpArchive' #(pointer) #uint32 )
	( 'ZpArchivePtr' #(pointer) #uint32 )
	( 'ZpGetOptionsPtr' #() #pointer )
	( 'ZpInit' #(pointer) #boolean )
	( 'ZpSetOptions' #(pointer) #uint32 )
	( 'ZpVersion' #() #uint32 )
	)!

structureNamed: aName
	" Private - Returns the platform structure named aName. "

	^(self classForStructureNamed: aName) new!

structureNamed: aName atAddress: anInteger
	" Private - Returns a platform structure named aName pointed by anInteger. "

	^(self classForStructureNamed: aName) address: anInteger! !

!WizDLL publicMethods !

archiver
	"Returns the current archiver in use."

	^WizArchiver current!

comment: buffer
	"Dummy comment method."

	| address |
	address := OSPointer fromInteger: buffer.
	address fillFromBytes: (ByteArray with: 0).
	^buffer!

options
	"Returns a structure with the current options."

	^self class
		structureNamed: 'ZPOPT'
		atAddress: self zpGetOptionsPtr "asExternalAddress"!

password: password n: n m: m name: name
	"Password entry method. If you have an encrypted file,
   this will probably give you great pain. Note that none of the
   parameters are being used here, and this will give you warnings."

	^self archiver
		getPassword: (String fromPointer: (OSPointer fromInteger: m))
		into: (OSPointer fromInteger: password)!

print: buffer count: size
	"Dummy print method that simply outputs what is sent from the dll."

	^self archiver print: buffer count: size!

version
	"Returns a structure with the current version."

	| result |
	result := self structureNamed: 'ZpVer'.
	self zpVersion: result asParameter.
	^result!

zpArchive: zcl
	"Perform all zip actions."

	"<api: 'ZpArchive' struct ulong>
	^self invalidArgument"

	^ZpArchive callWith: zcl!

zpArchivePtr: lpZCL
	"Perform all zip actions."

	"<api: 'ZpArchivePtr' struct ulong>
	^self invalidArgument"

	^ZpArchivePtr callWith: lpZCL!

zpGetOptionsPtr
	"Returns the options in the zip dll.
	It can be used to know if encription is supported."

	"<api: 'ZpGetOptionsPtr' ulongReturn>
	^self invalidArgument"

	^ZpGetOptionsPtr call!

zpInit: lpZipUserFunc
	"Initialize the receiver to perform zip archive."

	"<api: 'ZpInit' struct boolean>
	^self invalidArgument"

	^ZpInit callWith: lpZipUserFunc!

zpSetOptions: options
	"Set the options in the zip dll until such time as another call to this function is made.
	This must be made before the initial call to make or update an archive."

	"<api: 'ZpSetOptions' struct boolean>
	^self invalidArgument"

	^ZpSetOptions callWith: options!

zpVersion: zpVer
	"Return the unzip and dll versions in the ZpVer structure."

	"<api: 'ZpVersion' struct none>
	^self invalidArgument"
	^ZpVersion callWith: zpVer! !

!WizDLL privateMethods !

initialize
	" Private - initializes the receiver. "

	self initializeUserFunctions.!

initializeUserFunctions
	" Private - Initialize the receiver's user functions. "

	| functions |
	functions := self structureNamed: 'ZIPUSERFUNCTIONS'.
	functions
		print: (self class callbackFor: #printing on: self) address;
		comment: (self class callbackFor: #commenting on: self) address;
		password: (self class callbackFor: #encripting on: self) address;
		yourself.
	(self zpInit: functions asParameter)
	ifFalse: [ self error: 'Setting User Functions.' ].!

structureNamed: aName
	" Private - Returns the platform structure named aName. "

	^self class structureNamed: aName!

structureNamed: aName atAddress: anInteger
	" Private - Returns a platform structure named aName pointed by anInteger. "

	^self class structureNamed: aName atAddress: anInteger! !

!WizLibraryApp class privateMethods !

abtIsViewApplication

	^true! !

!ZCL class privateMethods !

initializeAfterLoad
	"  ZCL initializeAfterLoad	 "

	| fields |
	fields :=  #(
			argc
			lpszZipFN
			fnv
		).
	self
		fixedSize: 4 * fields size;
		members: fields! !

!ZCL publicMethods !

argc
	"Count of files to zip"

	^self uint32At: 0!

argc: anInteger
	"Count of files to zip"

	^self uint32At: 0 put: anInteger!

fnv
	"array of file names to zip up"

	^self uint32At: 8!

fnv: anInteger
	"array of file names to zip up"

	^self uint32At: 8 put: anInteger!

lpszZipFN
	"name of archive to create/update"

	^self uint32At: 4!

lpszZipFN: anInteger
	"name of archive to create/update"

	^self uint32At: 4 put: anInteger! !

!ZipUserFunctions class privateMethods !

initializeAfterLoad
	"  ZipUserFunctions initializeAfterLoad	 "

	| fields |
	fields :=  #(
			print
			comment
			password
		).
	self
		fixedSize: 4 * fields size;
		members: fields! !

!ZipUserFunctions publicMethods !

comment
	"comment callback address"

	^self uint32At: 4!

comment: anInteger
	"comment callback address"

	^self uint32At: 4 put: anInteger!

password
	"password callback address"

	^self uint32At: 8!

password: anInteger
	"password callback address"

	^self uint32At: 8 put: anInteger!

print
	"print callback address"

	^self uint32At: 0!

print: anInteger
	"print callback address"

	^self uint32At: 0 put: anInteger! !

!ZipVersionType class privateMethods !

initializeAfterLoad
	"  ZipVersionType initializeAfterLoad	 "

	| fields |
	fields :=  #(
			major
			minor
			patchlevel
			notUsed
		).
	self
		fixedSize: fields size * 1"byte";
		members: fields! !

!ZipVersionType publicMethods !

major
	"Returns the major version digit."

	^self uint8At: 0!

major: value
	"Set the major version digit."

	^self uint8At: 0 put: value!

minor
	"Returns the minor version digit."

	^self uint8At: 1!

minor: value
	"Set the minor version digit."

	^self uint8At: 1 put: value!

notUsed
	"Returns the notUsed version digit."

	^self uint8At: 3!

notUsed: value
	"Set the notUsed version digit."

	^self uint8At: 3 put: value!

patchlevel
	"Returns the patchlevel version digit."

	^self uint8At: 2!

patchlevel: value
	"Sets the patchlevel version digit."

	^self uint8At: 2 put: value! !

!ZpOptions class privateMethods !

initializeAfterLoad
	"  ZpOptions initializeAfterLoad	 "

	| fields |
	fields :=  #(
			suffix
			encrypt
			system
			volume
			extra
			noDirEntries
			excludeDate
			includeDate
			verbose
			quiet
			crlfLf
			lfCrlf
			junkDir
			recurse
			grow
			force
			move
			deleteEntries
			update
			freshen
			junkSFX
			latestTime
			comment
			offsets
			privilege
			encryption
			repair
			level
			date
			rootDir
		).
	self
		fixedSize: 4 * (fields size - 3) "booleans"
			+ 1 "level"
			+ 9 "date"
			+ 128 "rootDir";
		members: fields! !

!ZpOptions publicMethods !

comment
	"Put comment in zip file"

	^self bool32At: 88!

comment: aBoolean
	"Put comment in zip file"

	^self bool32At: 88 put: aBoolean!

crlfLf
	"Translate CR/LF to LF"

	^self bool32At: 40!

crlfLf: aBoolean
	"Translate CR/LF to LF"

	^self bool32At: 40 put: aBoolean!

date
	"Date to include after"

	^self copyStringFrom: 109 to: 118!

date: aString
	"Date to include after"

	^self
		replaceFrom: 109
		to: 109 + aString size
		with: aString asParameter
		startingAt: 1!

deleteEntries
	"Delete files from zip file"

	^self bool32At: 68!

deleteEntries: aBoolean
	"Delete files from zip file"

	^self bool32At: 68 put: aBoolean!

encrypt
	"encrypt files"

	^self bool32At: 4!

encrypt: aBoolean
	"encrypt files"

	^self bool32At: 4 put: aBoolean!

encryption
	"TRUE if encryption supported, else FALSE. This is a read only flag"

	^self bool32At: 100!

encryption: aBoolean
	"TRUE if encryption supported, else FALSE. This is a read only flag"

	^self bool32At: 100 put: aBoolean!

excludeDate
	"Exclude files earlier than specified date"

	^self bool32At: 24!

excludeDate: aBoolean
	"Exclude files earlier than specified date"

	^self bool32At: 24 put: aBoolean!

extra
	"Include extra attributes"

	^self bool32At: 16!

extra: aBoolean
	"Include extra attributes"

	^self bool32At: 16 put: aBoolean!

force
	"Make entries using DOS names (k for Katz)"

	^self bool32At: 60!

force: aBoolean
	"Make entries using DOS names (k for Katz)"

	^self bool32At: 60 put: aBoolean!

freshen
	"Freshen zip file--overwrite only"

	^self bool32At: 76!

freshen: aBoolean
	"Freshen zip file--overwrite only"

	^self bool32At: 76 put: aBoolean!

grow
	"Allow appending to a zip file"

	^self bool32At: 56!

grow: aBoolean
	"Allow appending to a zip file"

	^self bool32At: 56 put: aBoolean!

includeDate
	"Include only files earlier than specified date"

	^self bool32At: 28!

includeDate: aBoolean
	"Include only files earlier than specified date"

	^self bool32At: 28 put: aBoolean!

junkDir
	"Junk directory names"

	^self bool32At: 48!

junkDir: aBoolean
	"Junk directory names"

	^self bool32At: 48 put: aBoolean!

junkSFX
	"Junk SFX prefix"

	^self bool32At: 80!

junkSFX: aBoolean
	"Junk SFX prefix"

	^self bool32At: 80 put: aBoolean!

latestTime
	"Set zip file time to time of latest file in it"

	^self bool32At: 84!

latestTime: aBoolean
	"Set zip file time to time of latest file in it"

	^self bool32At: 84 put: aBoolean!

level
	"Compression level (0 - 9)"

	^self int8At: 108!

level: aByte
	"Compression level (0 - 9)"

	^self int8At: 108 put: aByte!

lfCrlf
	"Translate LF to CR/LF"

	^self bool32At: 44!

lfCrlf: aBoolean
	"Translate LF to CR/LF"

	^self bool32At: 44 put: aBoolean!

move
	"Delete files added or updated in zip file"

	^self bool32At: 64!

move: aBoolean
	"Delete files added or updated in zip file"

	^self bool32At: 64 put: aBoolean!

noDirEntries
	"Do not add directory entries"

	^self bool32At: 20!

noDirEntries: aBoolean
	"Do not add directory entries"

	^self bool32At: 20 put: aBoolean!

offsets
	"Update archive offsets for SFX files"

	^self bool32At: 92!

offsets: aBoolean
	"Update archive offsets for SFX files"

	^self bool32At: 92 put: aBoolean!

privilege
	"Use privileges (WIN32 only)"

	^self bool32At: 96!

privilege: aBoolean
	"Use privileges (WIN32 only)"

	^self bool32At: 96 put: aBoolean!

quiet
	"Quiet operation"

	^self bool32At: 36!

quiet: aBoolean
	"Quiet operation"

	^self bool32At: 36 put: aBoolean!

recurse
	"Recurse into subdirectories"

	^self bool32At: 52!

recurse: aBoolean
	"Recurse into subdirectories"

	^self bool32At: 52 put: aBoolean!

repair
		"Repair archive. 1 => -F, 2 => -FF"

	^self int32At: 104!

repair: anInteger
		"Repair archive. 1 => -F, 2 => -FF"

	^self int32At: 104 put: anInteger!

rootDir
	"Directory to use as base for zipping"

	^self copyStringFrom: 119 to: 119 + 127!

rootDir: aDir
	"Set Directory to use as base for zipping"

	^self
		replaceFrom: 119
		to: 119 + aDir size
		with: aDir asParameter
		startingAt: 1!

suffix
	"include suffixes (not implemented)"

	^self bool32At: 0!

suffix: aBoolean
	"include suffixes (not implemented)"

	^self bool32At: 0 put: aBoolean!

system
	"include system and hidden files"

	^self bool32At: 8!

system: aBoolean
	"include system and hidden files"

	^self bool32At: 8 put: aBoolean!

update
	"Update zip file--overwrite only if newer"

	^self bool32At: 72!

update: aBoolean
	"Update zip file--overwrite only if newer"

	^self bool32At: 72 put: aBoolean!

verbose
	"Mention oddities in zip file structure"

	^self bool32At: 32!

verbose: aBoolean
	"Mention oddities in zip file structure"

	^self bool32At: 32 put: aBoolean!

volume
	"Include volume label"

	^self bool32At: 12!

volume: aBoolean
	"Include volume label"

	^self bool32At: 12 put: aBoolean! !

!ZpVer class privateMethods !

initializeAfterLoad
	"  ZpVer initializeAfterLoad	 "

	| fields |
	fields :=  #(
			structlen
			flag
			betalevel
			date
			zlibVersion
			zip
			os2dll
			windll
		).
	self
		fixedSize: 
			4 * 2
			+ 10 " 'g BETA' or empty"
			+ 20 "date as string"
			+ 10 "zlibVersion"
			+ (ZipVersionType fixedSize * 3);
		members: fields! !

!ZpVer publicMethods !

betalevel
	" 'g BETA' or empty"

	^self copyStringFrom: 8 to: 17!

date

	^self copyStringFrom: 18 to: 37!

flag
	"bit 0: is_beta   bit 1: uses_zlib"

	^self uint32At: 4!

flag: anInteger
	"bit 0: is_beta   bit 1: uses_zlib"

	^self uint32At: 4 put: anInteger!

structlen
	"length of the struct being passed"

	^self uint32At: 0!

structlen: anInteger
	"length of the struct being passed"

	^self uint32At: 0 put: anInteger!

zlibVersion

	^self copyStringFrom: 38 to: 47! !

WizStructure initializeAfterLoad!
ZCL initializeAfterLoad!
ZipUserFunctions initializeAfterLoad!
ZipVersionType initializeAfterLoad!
ZpOptions initializeAfterLoad!
ZpVer initializeAfterLoad!
WizLibraryApp initializeAfterLoad!
WizObject initializeAfterLoad!
WizArchiver initializeAfterLoad!
WizDLL initializeAfterLoad!

WizLibraryApp loaded!